function [hl1, h, hm1, d] = geth(name)

global iy_ lgy_ ys_
global it_ ex_

it_ = size(ex_,1)+1;

step = 1e-8;

extname = [name,'_ff'];

neq = size(lgy_,1);
nex = size(ex_,2);

% initialize matrices
% leads
hl1 = zeros(neq);
% contemp.
h = hl1;
% lags
hm1 = hl1;
% innovations
d = zeros(neq,nex);

% find non-zero columns of hm1
lag_cols = find(iy_(1,:)~=0);
% find non-zero columns of h
con_cols = find(iy_(2,:));
% find non-zero columns of hl1
lea_cols = find(iy_(3,:));


% find number of entries for y vector
ny = length(find(iy_~=0));

% build steadt state y
y = ys_(lag_cols);
y = [y;ys_(con_cols)];
y = [y;ys_(lea_cols)];

% build hm1
nlag_cols = length(lag_cols);
for i=1:nlag_cols
    yp = y;
    ym = y;
    yp(i) = y(i) + step;
    ym(i) = ym(i) - step;
    eval(['zp =',extname,'(yp);'])
    eval(['zm =',extname,'(ym);'])
    deriv = (zp-zm)/(2*step);
    hm1(:,lag_cols(i)) = deriv;
end


% build h
ncon_cols = length(con_cols);
for i=1:ncon_cols
    yp = y;
    ym = y;
    yp(i+nlag_cols) = y(i+nlag_cols) + step;
    ym(i+nlag_cols) = ym(i+nlag_cols) - step;
    eval(['zp =',extname,'(yp);'])
    eval(['zm =',extname,'(ym);'])
    deriv = (zp-zm)/(2*step);
    h(:,con_cols(i)) = deriv;
end


% build hl1
nlea_cols = length(lea_cols);
offset = nlag_cols+ncon_cols;
for i=1:nlea_cols
    yp = y;
    ym = y;
    yp(i+offset) = y(i+offset) + step;
    ym(i+offset) = ym(i+offset) - step;
    eval(['zp =',extname,'(yp);'])
    eval(['zm =',extname,'(ym);'])
    deriv = (zp-zm)/(2*step);
    hl1(:,lea_cols(i)) = deriv;
end


exold = ex_;
for i=1:nex
    ex_ = exold;
    ex_(1,i) = exold(1,i)+step
    eval(['zp =',extname,'(y);'])
    ex_ = exold;
    ex_(1,i) = exold(1,i)-step
    eval(['zm =',extname,'(y);'])
    deriv = (zp-zm)/(2*step);
    d(:,i) = deriv;
end






