function history = mymkdata(dr_,ys_,nperiods,addss)

%  dr_ structure returned by dynare (AR form for the model)
%  lgy_ vector of variable names, returned by dynare
%  lgx_ vector of innovation names, returned by dynare
%  nperiods number of periods for IRFs
%  shock  vector to be used to generated irfs


% by default, make addss equal 1, so that the SS is added onto the IRFs
if nargin<4
    addss=1;
end

nvars = size(dr_.ghx,1);
statevar_pos = (dr_.nstatic +1):(nvars-dr_.nfwrd);
history = zeros(nvars,nperiods+1);

% history(:,2) = dr_.ghx*history(statevar_pos,1);
nshks = size(dr_.ghu,2);
for i = 2:nperiods+1 
    history(:,i) = dr_.ghx*history(statevar_pos,i-1) + dr_.ghu*randn(nshks,1);
end
   
if (addss~=0)
    history = history(:,2:end)+repmat(ys_(dr_.order_var),1,nperiods);
else
    % don't add ss if addss is set to 0;
    history = history(:,2:end);
end