% the q was added to the output by Phillip, 7/13
function [likel q history amatsmall endogsmall] = updatemod(params,paramlabels,olsparams,olsparamlabels,modnam,parnam1,parnam2,observedlabels,upperbound,lowerbound,listdrop,computeresid)


% implements penalty function to ensure function evaluation is within
% desired bounds

% declare data matrix as global
global zdata

% Define parameters and matrices for state and observable transition
% equations.
%
% The state evolution equation takes the form:
% b_k = T b_{k-1} + q w_k.
% The observable equation takes the form:
% y_k = Z b_{k} + r e_k.
% where w_k and e_k are drawn from a  multinormal distribution with variance sigma^2
%

penalty=0; penalty1=0;
q = 0;
history = 0;
amatsmall =0;
endogsmall=0;

% check inputs and modify them if outside boundaries (impose penalty later)
origparams = params;
params = min(max(params,lowerbound),upperbound);

% if max(abs(params-origparams)) >0
%     penalty1= 1;
% end

nparams = max(size(params));

for i=1:nparams
    eval([paramlabels(i,:),' = params(i);'])
end

%check that AR2 processes are stationary:
if max(abs([(rho_relpm1+sqrt(rho_relpm1^2+4*rho_relpm2))/2
        (rho_relpm1-sqrt(rho_relpm1^2+4*rho_relpm2))/2])) > 1
    penalty = 1;
end

%if (penalty ==0 & penalty1==0)
    % obtain decision rule
    parseflag = 0;
    [cofb,scof,endog_]=eggmodfunestim(modnam,parnam1,parnam2,parseflag,[params; olsparams],strvcat(paramlabels,olsparamlabels));
    eval(parnam1);

    [amat,bmat,endogs]=splitmat(cofb,scof,endog_,errlist,listdrop);
    %[amatsmall, bmatsmall, endogsmall]=shrinkspacesmall(amat,bmat,endogs,observedlabels);
    amatsmall = amat;
    bmatsmall = bmat;
    endogsmall = endogs;

    % check for stochastically singular variables if one is found get rid of it
    % only works if model is stationary
    %covbtmp = varsigma(amatsmall,bmatsmall*bmatsmall');
    %[amatsmall, bmatsmall,endogsmall] = checkvar(covbtmp,endogsmall,amatsmall,bmatsmall);

    % check for non-pivot variables in the decision rule
    % % % [R bj]=rref(amatsmall);
    % % % amatsmall = amatsmall(bj,bj);
    % % % bmatsmall = bmatsmall(bj,:);
    % % % endogsmall = endogsmall(bj,:);

    %penalty =0;
    nparams = max(size(params));

    T = amatsmall;

    q = bmatsmall;

    Q= q*q';

    nobserved = size(observedlabels,1);
    nendogsmall = size(endogsmall,1);
    Z = zeros(nobserved,nendogsmall);
    for observedindx=1:nobserved
        Z(observedindx,strmatch(observedlabels(observedindx,:),endogsmall,'exact'))=1;
    end


    r = zeros(nobserved,1);
    R = r*r';

    % Find unconditional variance of state vector
    % covb = varsigma(T,Q);

    %b0 = zeros(nendogsmall,1);
   
    % taylored initialization, uncomment line above to get something
    % that works in general
    b0 = [zdata(2,[1 3]),zdata(1,1),zdata(2,2)]';



    % defines size of training sample
    ntrains = 1;
    if nargin<12
        %        [likel]= newkalmangfast3(full(T),full(Z'),full(zdata'),full(b0),full(Q),ntrains);
        [likel]= kalmanfiltermatlab(T,Z',zdata',b0,Q,ntrains,params,paramlabels);
        history = [];
    else
        %[likel,history]= newkalmangfast4(full(T),full(Z'),full(zdata'),full(b0),full(Q),ntrains);
        [likel,error,history]= kalmanfiltermatlabhistory(T,Z',zdata',b0,Q,ntrains,params,paramlabels);
    end
%else

    % to do Unconditional maximum likelihood (only works if model is
    % stationary)
    %[likel xhistory ss]= kalmangfast(full(zdata'),full(Z),full(R),full(T),full(Q),full(b0),full(covb));
    likel = likel +10000*sum(abs(params-origparams)) ; 
%end

