function history = mymkirfdata(dr_,ys_,nperiods)

%  dr_ structure returned by dynare (AR form for the model)
%  lgy_ vector of variable names, returned by dynare
%  lgx_ vector of innovation names, returned by dynare
%  nperiods number of periods for IRFs
%  shock  vector to be used to generated irfs


% by default, make addss equal 0, so that the SS is not added on to the IRFs
addss=0;

nvars = size(dr_.ghx,1);
nshocks = size(dr_.ghu,2);
statevar_pos = (dr_.nstatic +1):(nvars-dr_.nfwrd);


history = zeros(nvars,nperiods+1);

history(:,2) = dr_.ghx*history(statevar_pos,1) + dr_.ghu*shock;
for i = 2:nperiods+1 
    history(:,i) = dr_.ghx*history(statevar_pos,i-1) + dr_.ghu*randn(nshocks,1);    
end

history = history(:,2:end);
