function [thetaunc, exitflag]=estimfundiffuse(observedlabels,params,TT,seed)

% variables inhereted from main program
global decrule endog_
global modnam parnam1 parnam2


% variables shared with other subfunctions 
% list also includes modnam parnam1 and parnam2
global zdata
global paramlabels upperbound lowerbound

% evaluate parameter files
eval(parnam1); eval(parnam2);

randn('seed',seed);
% generate data (uncomment line below if performing Monte Carlo
% experiments)
zdata = mkdata(TT+1000,decrule,endog_,observedlabels,errlist);
zdata = zdata(1001:1000+TT,:);



% modify the code below when importing observed data, rather than using synthetic Monte
% Carlo data.

% load mlestim.dat
% dates = 1973:.25:2006.75;
% startpos = find(dates==1983);
% zdata = 100*mlestim(startpos:end,[2 3 4]);
% mzdata=mean(zdata);
% for i=1:size(zdata,1)
%     zdata(i,:) = zdata(i,:)-mzdata;
% end

nvars=size(zdata,2);
for i=1:nvars 
    eval([observedlabels(i,:),'=zdata(:,i);']);
end


listdrop = makelistdrop(strvcat(slist,errlist),strvcat(slistfull,errlistfull));
[likel d] = updatediffuse(params,paramlabels,modnam,parnam1,parnam2,observedlabels,upperbound,lowerbound,listdrop);
                                         

display('Starting optimization')

options = optimset('GradObj','on','HessUpdate','bfgs','display','iter','MaxIter',20000,'MaxFunEvals',20000,'TolFun',1e-5,'TolX',1e-05);

%[thetaunc,fval,exitflag] = ...
%   fminunc('updatemod_d',params,options,...
%   paramlabels,modnam,parnam1,parnam2,observedlabels,upperbound,lowerbound,listdrop);
[thetaunc,fval,exitflag]=fmincombo('updatediffuse_d',params,options,...
         paramlabels,[],[],modnam,parnam1,parnam2,observedlabels,upperbound,lowerbound,listdrop)

     
                                         




               

