function [thetanew] = rescalekappa(theta0,psi0,alpha,beta,elast,elast_agg,omega)
%rescaling kappa for firm specific capital

%determine A and B from model without firm specific capital
A = ((1-beta*theta0)*(1-theta0)/theta0)*(1-psi0);
B = ((1-beta*theta0)*(1-theta0)/theta0)*psi0*(omega*elast_agg/elast);


psinew = B/(A*omega*(elast_agg/elast)+B);
kappa = A*(1+elast*(alpha/(1-alpha))*(1-psinew))/(1-psinew);

aa = beta;
bb = -(kappa+1+beta);
cc = 1;


thetanew = [(-bb+sqrt(bb^2-4*aa*cc))/(2*aa)
            (-bb-sqrt(bb^2-4*aa*cc))/(2*aa)];
        
solind = find(thetanew > 0 & thetanew < 1);
thetanew = thetanew(solind);


