clear
% sets the path to the AIM for Matlab routines needed in solving the model
setpathaim;

% modname below chooses model
% directory. But simple param choices are made from paramfile in current
% directory.
modnam = 'rbc';

TT = 100;            %length of IRFs

%model parameters
paramfilename1 = ['param'];
paramfilename2 = ['defparam'];

eval(paramfilename1); eval(paramfilename2);

% solve model 
% eggmodfun calls matlab AIM routine.
% eggmofunsparse calls mex file with sparse AIM routine.
% eggmodfunsparse is only marginally faster for small models.
%[decrule,endog_]=eggmodfun(modname,paramfilename);
[decrule,endog_,scof]=eggmodfun(modnam,paramfilename1,paramfilename2);

% generate model IRFs
% model name of variables whose responses we want to save
wishlist = char('k','c','invest','z');

irfshock ='err_z';
scalefactormod = 1;
% generate IRFs for wishlist. IRFs are save in ZDATA
zdata = mkdata(TT,decrule,endog_,wishlist,errlist,irfshock,scalefactormod);

% unpack ZDATA
nwishes = size(wishlist,1);
for i=1:nwishes
    eval([wishlist(i,:),'=zdata(:,i);']);
end

% make plot of IRFs
titlelist = char('Capital','Consumption','Investment','Technology');
figtitle = 'Technology shock';
legendlist = cellstr('Shock');
makechart(titlelist,legendlist,figtitle,[k,c,invest,z])

