function [likel d] = updatediffuse(params,paramlabels,modnam,parnam1,parnam2,observedlabels,upperbound,lowerbound,listdrop)

% declare data matrix as global
global zdata
% This routine follows the notation in Durbin and Koopman
% the filter takes the form
% transition equation
% alpha_{t+1} = T_t alpha_t + R_t eta_t
% observation equation
% y_t = Z_t alpha_t + epsilon_t
% eta_t is normally distributed with mean 0 and var/cov (Q)
% epsilon is normally distributed with mean 0 and var/cov (H)
% the vector y is {y_1, y_2, y_3,...,y_n}, where the observation vectors are
% stacked horizontally.
%
% the function returns -1 times the loglikelihood

% check inputs and modify them if outside boundaries (impose penalty later)
origparams = params;
params = min(max(params,lowerbound),upperbound);


% obtain decision rule
parseflag = 0;
[cofb,scof,endog_]=eggmodfunestim(modnam,parnam1,parnam2,parseflag,params,paramlabels);
eval(parnam1);
[amat,bmat,endog]=splitmat(cofb,scof,endog_,errlist,listdrop);
[amatsmall, bmatsmall, endogsmall]=shrinkspacesmall(amat,bmat,endog,observedlabels);

% check number of parameters to be estimated
nparams = max(size(params));


T = amatsmall;

R = bmatsmall;
R0 = R;

nobserved = size(observedlabels,1);
nendogsmall = size(endogsmall,1);
Z = zeros(nobserved,nendogsmall);
for observedindx=1:nobserved
    Z(observedindx,strmatch(observedlabels(observedindx,:),endogsmall,'exact'))=1;
end

a = zeros(nendogsmall,1);

A = eye(nendogsmall);

Q = eye(size(errlist,1));
Q0 = Q;

H = zeros(size(Z,1));

%P0 = R0*Q0*R0';

tol0 = 1;
[likel d]=kfdiffuse(zdata',a,A,R0,R,Q0,Q,T,Z,H,tol0);

likel = likel +10000*sum(abs(params-origparams));
