function [likel q history amatsmall endogsmall] = updatemod(params,paramlabels,olsparams,olsparamlabels,modnam,parnam1,parnam2,observedlabels,upperbound,lowerbound,listdrop,computeresid)


% implements penalty function to ensure function evaluation is within
% desired bounds

% declare data matrix as global
global zdata

% Define parameters and matrices for state and observable transition
% equations.
%
% The state evolution equation takes the form:
% b_k = T b_{k-1} + q w_k.
% The observable equation takes the form:
% y_k = Z b_{k} + r e_k.
% where w_k and e_k are drawn from a  multinormal distribution with variance sigma^2
%

penalty=0; penalty1=0;
q = 0;
history = 0;
amatsmall =0;
endogsmall=0;

% check inputs and modify them if outside boundaries (impose penalty later)
origparams = params;
params = min(max(params,lowerbound),upperbound);



nparams = max(size(params));

for i=1:nparams
    eval([paramlabels(i,:),' = params(i);'])
end


parseflag = 0;
[cofb,scof,endog_]=eggmodfunestim(modnam,parnam1,parnam2,parseflag,[params; olsparams],strvcat(paramlabels,olsparamlabels));
eval(parnam1);

[amat,bmat,endogs]=splitmat(cofb,scof,endog_,errlist,listdrop);
[amatsmall, bmatsmall, endogsmall]=shrinkspacesmall(amat,bmat,endogs,observedlabels);

%penalty =0;
nparams = max(size(params));

T = amatsmall;

q = bmatsmall;

Q= q*q';

nobserved = size(observedlabels,1);
nendogsmall = size(endogsmall,1);
Z = zeros(nobserved,nendogsmall);
for observedindx=1:nobserved
    Z(observedindx,strmatch(observedlabels(observedindx,:),endogsmall,'exact'))=1;
end


r = zeros(nobserved,1);
R = r*r';

% Find unconditional variance of state vector
% covb = varsigma(T,Q);

b0 = zeros(nendogsmall,1);

%b0 = [zdata(1,1); zdataplus(2,1)];
% defines size of training sample
ntrains = 10;
if nargin<12
    %        [likel]= newkalmangfast3(full(T),full(Z'),full(zdata'),full(b0),full(Q),ntrains);
    [likel]= kalmanfiltermatlab(T,Z',zdata',b0,Q,ntrains);
    history = [];
else
    %[likel,history]= newkalmangfast4(full(T),full(Z'),full(zdata'),full(b0),full(Q),ntrains);
    [likel,error,history]= kalmanfiltermatlabhistory(T,Z',zdata',b0,Q,ntrains);
end

likel = likel +10000*sum(abs(params-origparams)) ;

